@echo off
set TEMP_FILE=%1
set DBTYPE=%2
set DBHOST=""
set DBNAME=%3
set DBSCHEMA=%4
set DBPORT=%5
set USERNAME=%6
set PASSWORD=%7
for %%A in (%*) do set PROPS_FILE=%%A

mkdir %PROPS_FILE%.dir

set LOG_FILE="..\log\%PROPS_FILE%.log"
echo [%date%][%time%] "Processing started ..."> %LOG_FILE%

rem defining DBHOST
for /F "tokens=1,2 delims='='" %%i in (%PROPS_FILE%) do ( 
   if "%%i"=="SystemName" (
     for /F "tokens=1,2 delims= " %%a in ('echo %%j') do (
        set DBHOST=%%a
       )
     )
     
   if "%%i"=="SystemName " (
     for /F "tokens=1,2 delims= " %%a in ('echo %%j') do (
        set DBHOST=%%a
       )
     ) 
   )

if %DBTYPE% EQU "" (
  echo Warning: Missing Database product argument>> %LOG_FILE%
  echo [%date%][%time%] "Database product set to "DB2">> %LOG_FILE%
 set DBNAME="DB2"
)

if %DBHOST% EQU "" (
  echo Failure: Missing DBHOST argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)

if %DBNAME% EQU "" (
  echo Failure: Missing Database name argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)

if %DBPORT% EQU "" (
  echo Failure: Missing Database port argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)

if %DBSCHEMA% EQU "" (
  echo Failure: Missing Database schema argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)

if %USERNAME% EQU "" (
  echo Failure: Missing User name argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)

if %PASSWORD% EQU "" (
  echo Failure: Missing User password argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)

if %TEMP_FILE% EQU "" (
  echo Failure: Missing OUTPUT_FILE argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)

copy nul %TEMP_FILE%


for /F "delims=" %%i in ('@echo %PATH_GET%') do (set PATH_GET=%%~dpi) 

set SQLFILE="..\run\%PROPS_FILE%.dir\%PROPS_FILE%.sql"

echo SELECT * FROM  %DBSCHEMA%.AUDIT_EVENT left outer join %DBSCHEMA%.AUDIT_MGMT_TARGET on %DBSCHEMA%.AUDIT_EVENT.ID=%DBSCHEMA%.AUDIT_MGMT_TARGET.EVENT_ID left outer join %DBSCHEMA%.AUDIT_MGMT_DELEGATE on %DBSCHEMA%.AUDIT_EVENT.ID=%DBSCHEMA%.AUDIT_MGMT_DELEGATE.EVENT_ID left outer join %DBSCHEMA%.AUDIT_MGMT_PROVISIONING on %DBSCHEMA%.AUDIT_EVENT.ID=%DBSCHEMA%.AUDIT_MGMT_PROVISIONING.EVENT_ID > %SQLFILE%

java.exe -Dfile.encoding=UTF-8 -classpath "%CLASSPATH%;../bin/jdbc-genact.jar" eprise.audit.chunktool.generic.java.JdbcGenact -driver="db2" -host="%DBHOST%" -port="%DBPORT%" -database="%DBNAME%" -username="%USERNAME%" -passwd="%PASSWORD%" -props="%PROPS_FILE%" -outfilename="%TEMP_FILE%" -sqlfilename="%SQLFILE%" -useheaderline=yes  -separator=";" -eraseoutfile=yes -tdcolumn=TIMESTAMP -timecolumntype="string" -datetimeformat="yyyy-MM-dd HH:mm:ss:000 'GMT'" >> %LOG_FILE%

if %errorlevel% NEQ 0 (
  echo Failure: Collect process failed>> %LOG_FILE%
  echo [%date%][%time%] "Failure collecting audit trail.">> %LOG_FILE%
  exit /b 1
)

echo [%date%][%time%] "Success: Processing finished" >> %LOG_FILE%

rmdir %PROPS_FILE%.dir /S /q
exit /b 0