#!/bin/ksh
# Licensed Materials - Property of IBM
# 5724-S67
# (c) Copyright IBM Corp. 1998, 2007   All Rights Reserved.
# US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

# actuator progress log file name
LOG_FILE="../log/$PROPSFILE.log"

TRICKFILE="trick_$PROPSFILE"

# obtain hostname
HOST_NAME=`grep "SystemName" $PROPSFILE | tr "=" " " | awk '{print $2}'`

# set of  vars for sql-quary
SQL_FILE="vio.sql_$PROPSFILE"
TDCOLUMN="rundate"
IDCOLUMN=""
TABLENAME="jac_sys.violations"

# SQL-query for jac_sys.admin_log
echo "SELECT vio.*, snap.rundate, pol.name, comp.name from jac_sys.violations as vio left outer join jac_sys.snapshots as snap on vio.sna_id=snap.id left outer join jac_sys.policies as pol on snap.pol_id=pol.id left outer join jac_sys.compliance_sql as comp on vio.com_id=comp.id where vio.suppress is null order by snap.rundate" > $SQL_FILE

echo "Starting collect from table $TABLENAME" >> $LOG_FILE

# running gettscm_shared.sh
`../bin/gettscm_shared.sh "$TEMPFILE3" "$HOST_NAME" "$OPTION2" "$OPTION3" "$OPTION4" "$OPTION5" "$SQL_FILE" "$TDCOLUMN" "$IDCOLUMN"`

code=$?
if [ $code = 0 ];
then
   echo "Collect from table $TABLENAME is finished [SUCCESS]" >> $LOG_FILE
   echo "$TABLENAME -> SUCCESS" > $TRICKFILE
else
   echo "Warning: Collect from table $TABLENAME is finished [FAILURE]" >> $LOG_FILE
   touch $TEMPFILE3
fi

# delete error.sql file
rm -f $SQL_FILE

if [ -f "$TRICKFILE" ];
then
   echo "[`date`] Processing finished. [SUCCESS] " >> $LOG_FILE
   rm -f $TRICKFILE
   exit 0
else
   echo "[`date`] Processing finished. [FAILURE] " >> $LOG_FILE
   rm -f $TRICKFILE
   exit 1
fi


